﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private clv1 As CustomListView
	Private lbl1 As Label
	Private lbl2 As Label
	Private lbl3 As Label
	Private lbl4 As Label
	Private colorlistdialog As B4XDialog
	Private Button1 As Button
	Public dialogresult As Int
	Private Label1 As Label
	Public colorlist As List
	Private Label2 As Label
End Sub

Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	colorlistdialog.Initialize(Root)
	colorlistdialog.PutAtTop = True
	colorlistdialog.BackgroundColor = Colors.Gray
	load_colors_list
End Sub

Private Sub load_colors_list
	Dim jstr As String = File.ReadString(File.DirAssets,"colors.json")
	colorlist = jstr.As(JSON).ToList
	'Log(colorlist)
End Sub

Private Sub fill_clv1
	clv1.Clear
	For i = 0 To 9
		Dim pnl As Panel = clv1_item(i)
		clv1.Add(pnl,i)
	Next
End Sub

Private Sub clv1_item(cnt As Int) As Panel
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0dip, 0dip, clv1.AsView.Width,60dip)
	p.LoadLayout("clvitem_layout")
	p = set_colors_and_tag(p,cnt)
	Return p
End Sub

Private Sub set_colors_and_tag(pnl As Panel,cnt As Int) As Panel
	If (cnt*4)+1 < colorlist.size Then
		For x = 1 To 4
			Dim rec As List = colorlist.Get((cnt*4)+x)
			'Log(rec.Get(2))
			Dim clrstr As String = rec.Get(2)
			Dim R As Int = clrstr.SubString2(0,clrstr.IndexOf(","))
			Dim G As Int = clrstr.SubString2(clrstr.IndexOf(",")+1,clrstr.LastIndexOf(","))
			Dim B As Int = clrstr.SubString(clrstr.LastIndexOf(",")+1)
			Select x
				Case 1
					lbl1.Color = Colors.ARGB(255,R,G,B)
					lbl1.Tag = "clr_" & rec.Get(1) & "|" & clrstr
				Case 2
					lbl2.Color = Colors.ARGB(255,R,G,B)
					lbl2.Tag = "clr_" & rec.Get(1) & "|" & clrstr
				Case 3
					lbl3.Color = Colors.ARGB(255,R,G,B)
					lbl3.Tag = "clr_" & rec.Get(1) & "|" & clrstr
				Case 4
					lbl4.Color = Colors.ARGB(255,R,G,B)
					lbl4.Tag = "clr_" & rec.Get(1) & "|" & clrstr
			End Select
		Next
	End If
	Return pnl
End Sub

Private Sub clv1_ItemClick (Index As Int, Value As Object)
	'Log("index = " & Index)
	'Log("value = " & Value)
End Sub

Private Sub show_dialog
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0dip, 0dip, 0dip, 340dip, 500dip)
	pnl.LoadLayout("colorlistdialog_layout")
	fill_clv1
	Dim rsub1 As ResumableSub =  colorlistdialog.ShowCustom(pnl, "", "", "CANCEL")
	Wait For (rsub1) Complete (Result As Int)
	dialogresult = Result
	If Result = xui.dialogResponse_Positive Then
		'
	End If
End Sub

Private Sub lbl1_Click
	Dim lbl As Label = Sender
	Log(lbl.Tag)
	lbl.Text = "   OK"
	show_labels(lbl.Tag)
	'Sleep(1000)
	colorlistdialog.Close(dialogresult)
End Sub

Private Sub lbl2_Click
	Dim lbl As Label = Sender
	Log(lbl.Tag)
	lbl.Text = "   OK"
	show_labels(lbl.Tag)
	'Sleep(1000)
	colorlistdialog.Close(dialogresult)
End Sub

Private Sub lbl3_Click
	Dim lbl As Label = Sender
	Log(lbl.Tag)
	lbl.Text = "   OK"
	show_labels(lbl.Tag)
	'Sleep(1000)
	colorlistdialog.Close(dialogresult)
End Sub

Private Sub lbl4_Click
	Dim lbl As Label = Sender
	Log(lbl.Tag)
	lbl.Text = "   OK"
	show_labels(lbl.Tag)
	'Sleep(1000)
	colorlistdialog.Close(dialogresult)
End Sub

Private Sub show_labels(tag As String)
	Label1.text = "color: " & tag
	Dim clrstr As String = tag.SubString(tag.IndexOf("|")+1)
	Dim R As Int = clrstr.SubString2(0,clrstr.IndexOf(","))
	Dim G As Int = clrstr.SubString2(clrstr.IndexOf(",")+1,clrstr.LastIndexOf(","))
	Dim B As Int = clrstr.SubString(clrstr.LastIndexOf(",")+1)
	Label2.Color = Colors.ARGB(255,R,G,B)
End Sub

Private Sub Button1_Click
	Label1.Text = ""
	Label2.Color = xui.Color_White
	show_dialog
End Sub